/*
'' ============================================================================================
'' 项目名称：风越项目范例ASPX普通三层结构
'' 项目版本：V1.0
'' 项目描述：风越项目范例，用于建立ASPX普通三层结构
'' 文件名称：BLL_DEPARTMENT.cs
'' 文件描述：业务逻辑层 DEPARTMENT
'' 公司名称：中极网盛
'' 开发人员：刘怒
'' 创建日期：2008-12-25 20:23:50
'' 修订日期：2009-01-13 05:50:57
'' 版权信息：Copyright (C) 2008

'' 项目升级时需读取以下生成工具的版权信息
'' 生成工具：风越代码生成器 [FireCode Creator]
'' 当前版本：企业版 V1.5
'' 官方网站：http://www.sino8848.com
'' ============================================================================================
*/

using System;
using System.Data;
using System.Collections.Generic;
using Fyp_3TierCommon.Model;
using Fyp_3TierCommon.DAL;
using FypSystem.Common;

namespace Fyp_3TierCommon.BLL
{
    /// <summary>
    ///  DEPARTMENT 业务逻辑层
    /// </summary>
    public class BLL_DEPARTMENT
    {
        private readonly Fyp_3TierCommon.DAL.DAL_DEPARTMENT dal_DEPARTMENT = new Fyp_3TierCommon.DAL.DAL_DEPARTMENT();
        public BLL_DEPARTMENT()
        {
        }

        #region 记录是否存在
        /// <summary>
        /// 记录是否存在
        /// </summary>
        /// <param name="DEPARTMENT_ID">DEPARTMENT_ID</param>
        /// <returns></returns>
        public bool Exists(int? DEPARTMENT_ID)
        {
            return dal_DEPARTMENT.Exists(DEPARTMENT_ID);
        }
        #endregion

        #region 添加数据
        /// <summary>
        /// 添加数据
        /// </summary>
        /// <param name="model">DEPARTMENT实体对象</param>
        public void Add(Fyp_3TierCommon.Model.Model_DEPARTMENT model)
        {
            dal_DEPARTMENT.Add(model);
        }
        #endregion

        #region 更新数据
        /// <summary>
        /// 更新数据
        /// </summary>
        /// <param name="model">DEPARTMENT实体对象</param>
        public void Update(Fyp_3TierCommon.Model.Model_DEPARTMENT model)
        {
            dal_DEPARTMENT.Update(model);
        }
        #endregion

        #region 删除
        /// <summary>
        /// 删除
        /// </summary>
        /// <param name="DEPARTMENT_ID">DEPARTMENT_ID</param>
        public void Delete(int? DEPARTMENT_ID)
        {
            dal_DEPARTMENT.Delete(DEPARTMENT_ID);
        }
        #endregion

        #region 获取对象实体
        /// <summary>
        /// 获取对象实体
        /// </summary>
        /// <param name="DEPARTMENT_ID">DEPARTMENT_ID</param>
        /// <returns></returns>
        public Model_DEPARTMENT GetModel(int? DEPARTMENT_ID)
        {
            return dal_DEPARTMENT.GetModel(DEPARTMENT_ID);
        }
        #endregion

        #region 获取数据列表 DataSet
        /// <summary>
        /// 获取数据列表 DataSet
        /// </summary>
        /// <param name="strWhere">指定查询条件的SQL语句，不包含where</param>
        /// <returns></returns>
        public DataSet GetDataSet(string strWhere)
        {
            return dal_DEPARTMENT.GetDataSet(strWhere);
        }

		/// <summary>
		/// 获取全部数据列表 DataSet
		/// </summary>
		public DataSet GetDataSet()
		{
			return GetDataSet("");
		}
        #endregion

        #region 获取数据列表 DataTable
        /// <summary>
        /// 获取数据列表 DataTable
        /// </summary>
        /// <param name="strWhere">指定查询条件的SQL语句，不包含where</param>
        /// <returns></returns>
        public DataTable GetDataTable(string strWhere)
        {
            return dal_DEPARTMENT.GetDataTable(strWhere);
        }

        /// <summary>
        /// 获取数据列表 DataTable
        /// </summary>
        /// <param name="strWhere">指定查询条件的SQL语句，不包含where</param>
        /// <param name="strOrder">排序字段，如id desc，不包含order by</param>
        /// <returns></returns>
        public DataTable GetDataTable(string strWhere, string strOrder)
        {
            return dal_DEPARTMENT.GetDataTable(strWhere, strOrder);
        }

		/// <summary>
		/// 获取全部数据列表 DataTable
		/// </summary>
		public DataTable GetDataTable()
		{
			return GetDataTable("");
		}
        #endregion

        #region 获取数据列表 Model List
        /// <summary>
        /// 获取数据列表 Model List
        /// </summary>
        /// <param name="strWhere">查询条件的SQL语句，不包含where</param>
        /// <returns></returns>
        public List<Fyp_3TierCommon.Model.Model_DEPARTMENT> GetModelList(string strWhere)
        {
            DataSet ds = dal_DEPARTMENT.GetDataSet(strWhere);
            List<Fyp_3TierCommon.Model.Model_DEPARTMENT> modelList = new List<Fyp_3TierCommon.Model.Model_DEPARTMENT>();
            int iRowsCount = ds.Tables[0].Rows.Count;
            if (iRowsCount > 0)
            {
                Fyp_3TierCommon.Model.Model_DEPARTMENT model;
                for (int i = 0; i < iRowsCount; i++)
                {
                    model = new Fyp_3TierCommon.Model.Model_DEPARTMENT();
                    DataRow dr = ds.Tables[0].Rows[i];

                    if (dr["DEPARTMENT_ID"].ToString().Length > 0)
                    {
                        model.DEPARTMENT_ID = int.Parse(dr["DEPARTMENT_ID"].ToString());
                    }

                    if (dr["COMPANY_ID"].ToString().Length > 0)
                    {
                        model.COMPANY_ID = int.Parse(dr["COMPANY_ID"].ToString());
                    }

                    model.DEPARTMENT_NAME = dr["DEPARTMENT_NAME"].ToString();

                    modelList.Add(model);
                }
            }
            return modelList;
        }
        #endregion
    }
}